## yubihsm-shell 2.7.0

=== CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required (VERSION 3.5)
# policy CMP0025 is to get AppleClang identifier rather than Clang for both
# this matters since the apple compiler accepts different flags.
cmake_policy(SET CMP0025 NEW)
cmake_policy(SET CMP0042 NEW)
cmake_policy(SET CMP0054 NEW)
cmake_policy(SET CMP0091 NEW)

project (yubihsm-shell)

option(BUILD_ONLY_LIB "Library only build" OFF)
option(SUPRESS_MSVC_WARNINGS "Suppresses a lot of the warnings when compiling with MSVC" ON)
option(ENABLE_STATIC "Compiles libyubihsm as a static library (in addtion to the dynamic library)" OFF)
option(ENABLE_CERT_COMPRESS "Enable/disable certificate compression" ON)

if(ENABLE_CERT_COMPRESS)
  message(STATUS "Certificate compression is enabled.")
  add_definitions(-DENABLE_CERT_COMPRESS)
else ()
  message(STATUS "Certificate compression is disabled.")
endif()

include(${CMAKE_SOURCE_DIR}/cmake/Fuzzing.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/SecurityFlags.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

# Set various install paths
if (NOT DEFINED YUBIHSM_INSTALL_LIB_DIR)
  set(YUBIHSM_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "Installation directory for libraries")
endif ()

if (NOT DEFINED YUBIHSM_INSTALL_INC_DIR)
  set(YUBIHSM_INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Installation directory for headers")
endif ()

if (NOT DEFINED YUBIHSM_INSTALL_BIN_DIR)
  set(YUBIHSM_INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")
endif ()

if (NOT DEFINED YUBIHSM_INSTALL_MAN_DIR)
  set(YUBIHSM_INSTALL_MAN_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Installation directory for manual pages")
endif ()

if (NOT DEFINED YUBIHSM_INSTALL_PKGCONFIG_DIR)
  set(YUBIHSM_INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/share/pkgconfig" CACHE PATH "Installation directory for pkgconfig (.pc) files")
endif ()

if (NOT CMAKE_BUILD_TYPE)
   if (${RELEASE_BUILD} MATCHES 1)
      set (CMAKE_BUILD_TYPE Release)
   else ()
      set (CMAKE_BUILD_TYPE Debug)
   endif ()
endif ()

if(MSVC)
  set(DISABLE_LTO 1)
endif()
if (NOT DISABLE_LTO)
  if (CMAKE_C_COMPILER_ID STREQUAL GNU)
    if (CMAKE_C_COMPILER_VERSION VERSION_GREATER 6.0)
      set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto")
    endif ()
  else ()
    if (CMAKE_C_COMPILER_VERSION VERSION_GREATER 7.0)
      set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto")
    endif ()
  endif ()
endif ()

if (CMAKE_C_COMPILER_ID STREQUAL AppleClang)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-nullability-completeness -Wno-nullability-extension -Wno-expansion-to-defined -Wno-undef-prefix -Wno-extra-semi")
elseif (NOT MSVC)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-braces -Wno-missing-field-initializers")
  # -Wl,--strip-all is dependent on linker not compiler...
  set (CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--strip-all")
endif ()

if (CMAKE_MAJOR_VERSION LESS 3)
  if (CMAKE_C_COMPILER_ID STREQUAL GNU)
    # The C_STANDARD property was introduced in cmake 3.1
    # https://cmake.org/cmake/help/latest/prop_tgt/C_STANDARD.html
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
  endif ()
else ()
  set (CMAKE_C_STANDARD 11)
endif ()

set (yubihsm_shell_VERSION_MAJOR 2)
set (yubihsm_shell_VERSION_MINOR 7)
set (yubihsm_shell_VERSION_PATCH 0)
set (VERSION "${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}")

if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(ENV{PKG_CONFIG_PATH} "/usr/libdata/pkgconfig:$ENV{PKG_CONFIG_PATH}")
endif ()

if (NOT DEFINED DEFAULT_CONNECTOR_URL)
  set (DEFAULT_CONNECTOR_URL "http://localhost:12345")
endif()

add_definitions(-DDEFAULT_CONNECTOR_URL="${DEFAULT_CONNECTOR_URL}")

enable_testing()
find_package(codecov)

add_definitions(-DOPENSSL_API_COMPAT=0x10000000L)

if(WIN32)
  add_definitions(-DWIN32_LEAN_AND_MEAN=1)
  set(_WIN32 1)
  set(__WIN32 1)
  set(_WIN32_BCRYPT 1)
endif()

if(MSVC)
  message("win32")
  set(_MSVC 1)

  if(SUPRESS_MSVC_WARNINGS)
  set(MSVC_DISABLED_WARNINGS_LIST
            "C4706" # assignment within conditional expression;
            "C4996" # The POSIX name for this item is deprecated. Instead, use the ISO C and C++ conformant name
            "C4005" # redefinition of micros. Status codes are defined in winnt.h and then redefined in ntstatus.h with the same values
            "C4244" # conversion of size_t to other types. Since we don't have sizes that occupy more than 2 bytes, this should be safe to ignore
            "C4267" # conversion of size_t to other types. Since we don't have sizes that occupy more than 2 bytes, this should be safe to ignore
            "C4100" # unreferenced formal parameter
            "C4201" # nonstandard extension used: nameless struct/union
            "C4295" # array is too small to include a terminating null character. They arrays it's complaining about aren't meant to include terminating null character (triggered in tests and examples only)
            "C4127" # conditional expression is constant
            "C5105" # macro expansion producing 'defined' has undefined behavior
            "C4018" # signed/unsigned mismatch
            )
    # The construction in the following 3 lines was taken from LibreSSL's
    # CMakeLists.txt.
    string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR ${MSVC_DISABLED_WARNINGS_LIST})
    string(REGEX REPLACE "[/-]W[1234][ ]?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 ${MSVC_DISABLED_WARNINGS_STR}")
  endif(SUPRESS_MSVC_WARNINGS)
  set (WITHOUT_MANPAGES 1)
  if (NOT WITHOUT_WIN32_BCRYPT)
    set (WIN32_BCRYPT 1)
  endif()
else()
  message(STATUS "not win32")

  include(CheckFunctionExists)

  check_function_exists(memset_s HAVE_MEMSET_S)
  if (HAVE_MEMSET_S)
    add_definitions (-DHAVE_MEMSET_S)
  endif()

  check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
  if (HAVE_EXPLICIT_BZERO)
    add_definitions (-DHAVE_EXPLICIT_BZERO)
  endif ()

  find_package (PkgConfig REQUIRED)
  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    if (NOT LIBCRYPTO_LDFLAGS)
      set (LIBCRYPTO_LDFLAGS "-lcrypto")
    endif()
    if (NOT LIBCRYPTO_VERSION)
      set (LIBCRYPTO_VERSION "1.1.1")
    endif()
  else()
    include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
    find_libcrypto()
  endif()
  if(NOT BUILD_ONLY_LIB)
    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
      set (LIBEDIT_LDFLAGS "-ledit")
    else()
      pkg_search_module (LIBEDIT REQUIRED libedit)
    endif()
  endif()
  pkg_search_module (LIBCURL REQUIRED libcurl)
  pkg_search_module (LIBUSB REQUIRED libusb-1.0)
endif()

message("LIBCRYPTO_VERSION: ${LIBCRYPTO_VERSION}")

add_subdirectory (lib)

if(NOT BUILD_ONLY_LIB)
  add_subdirectory (pkcs11)

  if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    pkg_search_module (LIBPCSC REQUIRED libpcsclite)
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set (LIBPCSC_LDFLAGS "winscard.lib")
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(LIBPCSC_LDFLAGS "-Wl,-framework -Wl,PCSC")
  endif()

  add_subdirectory (ykhsmauth)
  add_subdirectory (yubihsm-auth)

  add_subdirectory (src)

  add_subdirectory (examples)

  add_subdirectory(yhwrap)
endif()

add_custom_target (
  cppcheck
  COMMENT "Running cppcheck"
  COMMAND cppcheck
  --enable=warning,style,unusedFunction,missingInclude
  --template="[{severity}][{id}] {message} {callstack} \(On {file}:{line}\)"
  -i ${CMAKE_SOURCE_DIR}/src/cmdline.c
  -i ${CMAKE_SOURCE_DIR}/pkcs11/cmdline.c
  --verbose
  --quiet
  ${CMAKE_SOURCE_DIR}/lib ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/pkcs11
  )

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH})
add_custom_target (
  dist
  COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD | gzip > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.gz
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  )

coverage_evaluate()


message("Build summary:")
message("")
message("        Project name:     ${CMAKE_PROJECT_NAME}")
message("        Version:          ${VERSION}")
message("        Host type:        ${CMAKE_SYSTEM_NAME}")
message("        Path prefix:      ${CMAKE_PREFIX_PATH}")
message("        Compiler:         ${CMAKE_C_COMPILER}")
message("        Compiler ID:      ${CMAKE_C_COMPILER_ID}")
message("        Compiler version: ${CMAKE_C_COMPILER_VERSION}")
message("        CMake version:    ${CMAKE_VERSION}")
message("        CFLAGS:           ${CMAKE_C_FLAGS}")
message("        CPPFLAGS:         ${CMAKE_CXX_FLAGS}")
message("        Warnings:         ${WARN_FLAGS}")
message("        Build type:       ${CMAKE_BUILD_TYPE}")
message("")
message("        Install prefix:    ${CMAKE_INSTALL_PREFIX}")
message("        Install targets")
message("             Libraries     ${YUBIHSM_INSTALL_LIB_DIR}")
message("             Includes      ${YUBIHSM_INSTALL_INC_DIR}")
message("             Binaries      ${YUBIHSM_INSTALL_BIN_DIR}")
message("             Manuals       ${YUBIHSM_INSTALL_MAN_DIR}")
message("             Pkg-config    ${YUBIHSM_INSTALL_PKGCONFIG_DIR}")

=== examples/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()

set (
  SOURCE_IMPORT_RSA
  import_rsa.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_GENERATE_EC
  generate_ec.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCEINFO
  info.c
  )

set (
  SOURCE_IMPORT_AUTHKEY
  import_authkey.c
  )

set (
  SOURCE_GENERATE_HMAC
  generate_hmac.c
  )

set (
  SOURCE_WRAP
  wrap.c
  ../common/util.c
  ../common/hash.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_WRAP_DATA
  wrap_data.c
  )

set (
  SOURCE_ATTEST
  attest.c
  ../common/util.c
  ../common/hash.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_YUBICO_OTP
  yubico_otp.c
  )

set (
  SOURCE_ECHO
  echo.c
  )

set (
  SOURCE_ASYM_AUTH
  asym_auth.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_IMPORT_EC
  import_ec.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_GENERATE_RSA
  generate_rsa.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_LOGS
  logs.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_SSH
  ssh.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_DECRYPT_RSA
  decrypt_rsa.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_P11_GENERATE_RSA
  p11_generate_rsa.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_DECRYPT_EC
  decrypt_ec.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_IMPORT_ED
  import_ed.c
  ../common/hash.c
  ../common/util.c
  ../common/openssl-compat.c
  )

set (
  SOURCE_CHANGE_AUTHKEY
  change_authkey.c
  )

set(
  SOURCE_ENCRYPT_AES
  encrypt_aes.c
)

include_directories (
  ${LIBCRYPTO_INCLUDEDIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/../lib
  ${CMAKE_CURRENT_SOURCE_DIR}/../pkcs11
  ${CMAKE_CURRENT_SOURCE_DIR}/../common
  )

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/rsa2048_pvtkey.pem
  ${CMAKE_CURRENT_BINARY_DIR}/rsa2048_pvtkey.pem
  COPYONLY)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/p256_pvtkey.pem
  ${CMAKE_CURRENT_BINARY_DIR}/p256_pvtkey.pem
  COPYONLY)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/attestation_template.pem
  ${CMAKE_CURRENT_BINARY_DIR}/attestation_template.pem
  COPYONLY)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/ssh_ca_pvtkey.pem
  ${CMAKE_CURRENT_BINARY_DIR}/ssh_ca_pvtkey.pem
  COPYONLY)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/ssh_req.dat
  ${CMAKE_CURRENT_BINARY_DIR}/ssh_req.dat
  COPYONLY)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/ed25519_pvtkey.pem
  ${CMAKE_CURRENT_BINARY_DIR}/ed25519_pvtkey.pem
  COPYONLY)

add_executable (import_rsa ${SOURCE_IMPORT_RSA})

target_link_libraries (
  import_rsa
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (generate_ec ${SOURCE_GENERATE_EC})

target_link_libraries (
  generate_ec
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (info ${SOURCEINFO})

target_link_libraries (
  info
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (import_authkey ${SOURCE_IMPORT_AUTHKEY})

target_link_libraries (
  import_authkey
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (generate_hmac ${SOURCE_GENERATE_HMAC})

target_link_libraries (
  generate_hmac
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (wrap ${SOURCE_WRAP})

target_link_libraries (
  wrap
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (wrap_data ${SOURCE_WRAP_DATA})

target_link_libraries (
  wrap_data
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (attest ${SOURCE_ATTEST})

target_link_libraries (
  attest
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (yubico_otp ${SOURCE_YUBICO_OTP})

target_link_libraries (
  yubico_otp
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (echo ${SOURCE_ECHO})

target_link_libraries (
  echo
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (asym_auth ${SOURCE_ASYM_AUTH})

target_link_libraries (
  asym_auth
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (import_ec ${SOURCE_IMPORT_EC})

target_link_libraries (
  import_ec
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (generate_rsa ${SOURCE_GENERATE_RSA})

target_link_libraries (
  generate_rsa
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (logs ${SOURCE_LOGS})

target_link_libraries (
  logs
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (ssh ${SOURCE_SSH})

target_link_libraries (
  ssh
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (decrypt_rsa ${SOURCE_DECRYPT_RSA})

target_link_libraries (
  decrypt_rsa
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (decrypt_ec ${SOURCE_DECRYPT_EC})

target_link_libraries (
  decrypt_ec
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (import_ed ${SOURCE_IMPORT_ED})

target_link_libraries (
  import_ed
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable (change_authkey ${SOURCE_CHANGE_AUTHKEY})

target_link_libraries (
  change_authkey
  ${LIBCRYPTO_LDFLAGS}
  yubihsm
  )

add_executable(encrypt_aes ${SOURCE_ENCRYPT_AES})

target_link_libraries(
  encrypt_aes
  yubihsm
)

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  add_executable (p11_generate_rsa ${SOURCE_P11_GENERATE_RSA})

  target_link_libraries (
    p11_generate_rsa
    ${LIBCRYPTO_LDFLAGS}
    dl
    )
endif()

=== lib/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

if(${WIN32_BCRYPT})
else(${WIN32_BCRYPT})
  include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
  find_libcrypto()
endif(${WIN32_BCRYPT})

if(MSVC)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif()

set (
  SOURCE
  ${CMAKE_CURRENT_SOURCE_DIR}/../aes_cmac/aes.c
  ${CMAKE_CURRENT_SOURCE_DIR}/../aes_cmac/aes_cmac.c
  ${CMAKE_CURRENT_SOURCE_DIR}/../common/hash.c
  ${CMAKE_CURRENT_SOURCE_DIR}/../common/pkcs5.c
  ${CMAKE_CURRENT_SOURCE_DIR}/../common/rand.c
  ${CMAKE_CURRENT_SOURCE_DIR}/../common/ecdh.c
  error.c
  lib_util.c
  yubihsm.c
)

if (ENABLE_CERT_COMPRESS)
  set(SOURCE ${SOURCE} data_compress.c)
  include(${CMAKE_SOURCE_DIR}/cmake/zlib.cmake)
  find_zlib()
endif()

if(MSVC)
  set(SOURCE ${SOURCE} ${CMAKE_CURRENT_SOURCE_DIR}/../common/time_win.c)
endif(MSVC)
set(STATIC_SOURCE ${SOURCE})

if(NOT ${WIN32_BCRYPT})
  set(SOURCE ${SOURCE} ${CMAKE_CURRENT_SOURCE_DIR}/../common/openssl-compat.c)
endif(NOT ${WIN32_BCRYPT})
set (STATIC_SOURCE ${SOURCE})

if(WIN32)
  set(ADDITIONAL_LIBRARY ws2_32)
  set (
    HTTP_SOURCE
    yubihsm_winhttp.c
    lib_util.c
    ${CMAKE_CURRENT_BINARY_DIR}/version_winhttp.rc
    ${CMAKE_CURRENT_SOURCE_DIR}/../common/time_win.c
    )
  set (
    USB_SOURCE
    yubihsm_usb.c
    yubihsm_winusb.c
    lib_util.c
    ${CMAKE_CURRENT_BINARY_DIR}/version_winusb.rc
    ${CMAKE_CURRENT_SOURCE_DIR}/../common/time_win.c
    )
  set(HTTP_LIBRARY winhttp ws2_32)
  set(USB_LIBRARY winusb ws2_32 setupapi)

  if(${WIN32_BCRYPT})
    set (CRYPT_LIBRARY bcrypt)
    add_definitions (-D_WIN32_BCRYPT)
  else(${WIN32_BCRYPT})
    set(CRYPT_LIBRARY ${LIBCRYPTO_LDFLAGS})
  endif(${WIN32_BCRYPT})
  list(APPEND SOURCE ${CMAKE_CURRENT_BINARY_DIR}/version.rc)

  list(APPEND STATIC_SOURCE yubihsm_winusb.c yubihsm_usb.c yubihsm_winhttp.c)
else(WIN32)
  set(ADDITIONAL_LIBRARY -ldl)
  set (
    USB_SOURCE
    yubihsm_usb.c
    yubihsm_libusb.c
    lib_util.c
    )
  set (
    HTTP_SOURCE
    yubihsm_curl.c
    lib_util.c
    )
  set(HTTP_LIBRARY ${LIBCURL_LDFLAGS})
  set(USB_LIBRARY ${LIBUSB_LDFLAGS})
  set(CRYPT_LIBRARY ${LIBCRYPTO_LDFLAGS})

  list(APPEND STATIC_SOURCE yubihsm_libusb.c yubihsm_usb.c yubihsm_curl.c)

  if(FUZZING)
    add_executable(fuzz_send_plain_msg ${SOURCE} fuzz/fuzz_send_plain_msg.cc fuzz/yubihsm_fuzz.cc)
    set_target_properties (fuzz_send_plain_msg PROPERTIES COMPILE_FLAGS "-DSTATIC -fsanitize=fuzzer ")
    set_target_properties (fuzz_send_plain_msg PROPERTIES LINK_FLAGS "-fsanitize=fuzzer ")
    target_link_libraries (fuzz_send_plain_msg ${LIBCRYPTO_LDFLAGS})

    add_executable(fuzz_send_secure_msg ${SOURCE} fuzz/fuzz_send_secure_msg.cc fuzz/yubihsm_fuzz.cc)
    set_target_properties (fuzz_send_secure_msg PROPERTIES COMPILE_FLAGS "-DSTATIC -fsanitize=fuzzer ")
    set_target_properties (fuzz_send_secure_msg PROPERTIES LINK_FLAGS "-fsanitize=fuzzer ")
    target_link_libraries (fuzz_send_secure_msg ${LIBCRYPTO_LDFLAGS})
  endif(FUZZING)
endif(WIN32)

include_directories (
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${LIBCRYPTO_INCLUDEDIR}
  ${LIBCURL_INCLUDEDIR}
)

add_library (yubihsm SHARED ${SOURCE})
add_library (yubihsm_usb SHARED ${USB_SOURCE})
add_library (yubihsm_http SHARED ${HTTP_SOURCE})

set_target_properties(yubihsm PROPERTIES BUILD_RPATH "${CMAKE_BINARY_DIR}/lib")
set_target_properties (yubihsm PROPERTIES VERSION "${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}" SOVERSION ${yubihsm_shell_VERSION_MAJOR})
set_target_properties (yubihsm_usb PROPERTIES VERSION "${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}" SOVERSION ${yubihsm_shell_VERSION_MAJOR})
set_target_properties (yubihsm_http PROPERTIES VERSION "${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}" SOVERSION ${yubihsm_shell_VERSION_MAJOR})
if(MSVC)
  set_target_properties(yubihsm PROPERTIES OUTPUT_NAME libyubihsm)
  set_target_properties(yubihsm_usb PROPERTIES OUTPUT_NAME libyubihsm_usb)
  set_target_properties(yubihsm_http PROPERTIES OUTPUT_NAME libyubihsm_http)
else(MSVC)
  set_target_properties(yubihsm PROPERTIES OUTPUT_NAME yubihsm)
  set_target_properties(yubihsm_usb PROPERTIES OUTPUT_NAME yubihsm_usb)
  set_target_properties(yubihsm_http PROPERTIES OUTPUT_NAME yubihsm_http)
endif(MSVC)

if (ENABLE_STATIC)
  add_library (yubihsm_static STATIC ${STATIC_SOURCE})
  set_target_properties (yubihsm_static PROPERTIES POSITION_INDEPENDENT_CODE on OUTPUT_NAME yubihsm)
  set_target_properties (yubihsm_static PROPERTIES COMPILE_FLAGS "-DSTATIC " )
  if(MSVC)
    set_property(TARGET yubihsm_static PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
  endif(MSVC)
  add_coverage (yubihsm_static)
endif()

if(${WIN32})
else(${WIN32})
  if(${LIBUSB_VERSION} VERSION_LESS 1.0.16)
    set(LIBUSB_CFLAGS "${LIBUSB_CFLAGS} -DNO_LIBUSB_STRERROR")
  endif()
  set_target_properties (yubihsm_usb PROPERTIES COMPILE_FLAGS ${LIBUSB_CFLAGS})
  if(ENABLE_STATIC)
    set_property(TARGET yubihsm_static APPEND_STRING PROPERTY COMPILE_FLAGS ${LIBUSB_CFLAGS})
  endif(ENABLE_STATIC)
endif(${WIN32})

add_coverage (yubihsm)
add_coverage (yubihsm_usb)
add_coverage (yubihsm_http)

add_definitions (-DVERSION="${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}")
add_definitions (-DSOVERSION="${yubihsm_shell_VERSION_MAJOR}")

target_link_libraries (yubihsm ${CRYPT_LIBRARY} ${ADDITIONAL_LIBRARY} ${ZLIB_LIBS})
target_link_libraries (yubihsm_usb ${USB_LIBRARY})
target_link_libraries (yubihsm_http ${HTTP_LIBRARY})
if(ENABLE_STATIC)
  target_link_libraries (yubihsm_static ${CRYPT_LIBRARY} ${ADDITIONAL_LIBRARY} ${HTTP_LIBRARY} ${USB_LIBRARY} ${ZLIB_LIBS})
endif(ENABLE_STATIC)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/yubihsm.pc.in ${CMAKE_CURRENT_BINARY_DIR}/yubihsm.pc @ONLY)
configure_file(${CMAKE_SOURCE_DIR}/common/platform-config.h.in ${CMAKE_SOURCE_DIR}/common/platform-config.h @ONLY)

if(WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version_winhttp.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version_winhttp.rc @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version_winusb.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version_winusb.rc @ONLY)
endif(WIN32)

install(
  TARGETS yubihsm
  ARCHIVE DESTINATION ${YUBIHSM_INSTALL_LIB_DIR}
  LIBRARY DESTINATION ${YUBIHSM_INSTALL_LIB_DIR}
  RUNTIME DESTINATION ${YUBIHSM_INSTALL_BIN_DIR})
install(
  TARGETS yubihsm_usb
  ARCHIVE DESTINATION ${YUBIHSM_INSTALL_LIB_DIR}
  LIBRARY DESTINATION ${YUBIHSM_INSTALL_LIB_DIR}
  RUNTIME DESTINATION ${YUBIHSM_INSTALL_BIN_DIR})
install(
  TARGETS yubihsm_http
  ARCHIVE DESTINATION ${YUBIHSM_INSTALL_LIB_DIR}
  LIBRARY DESTINATION ${YUBIHSM_INSTALL_LIB_DIR}
  RUNTIME DESTINATION ${YUBIHSM_INSTALL_BIN_DIR})
install(FILES yubihsm.h DESTINATION ${YUBIHSM_INSTALL_INC_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/yubihsm.pc DESTINATION ${YUBIHSM_INSTALL_PKGCONFIG_DIR})

add_subdirectory (tests)

add_test(
  NAME parsing
  COMMAND test_parsing
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
  )

add_test(
  NAME pbkdf2
  COMMAND test_pbkdf2
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
  )

add_test(
  NAME attest
  COMMAND attest
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/examples/
  )

add_test(
  NAME generate_ec
  COMMAND generate_ec
  )

add_test(
  NAME generate_hmac
  COMMAND generate_hmac
  )

add_test(
  NAME import_authkey
  COMMAND import_authkey
  )

add_test(
  NAME import_rsa
  COMMAND import_rsa
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/examples/
  )

add_test(
  NAME info
  COMMAND info
  )

add_test(
  NAME wrap
  COMMAND wrap
  )

add_test(
  NAME wrap_data
  COMMAND wrap_data
  )

add_test(
  NAME yubico_otp
  COMMAND yubico_otp
  )

add_test(
  NAME echo
  COMMAND echo
  )

add_test(
  NAME asym_auth
  COMMAND asym_auth
  )

add_test(
  NAME import_ec
  COMMAND import_ec
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/examples/
  )

add_test(
  NAME generate_rsa
  COMMAND generate_rsa
  )

add_test(
  NAME logs
  COMMAND logs
  )

add_test(
  NAME ssh
  COMMAND ssh
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/examples/
  )

add_test(
  NAME decrypt_rsa
  COMMAND decrypt_rsa
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/examples/
  )

add_test(
  NAME decrypt_ec
  COMMAND decrypt_ec
  )

add_test(
  NAME import_ed
  COMMAND import_ed
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/examples/
  )

add_test(
  NAME change_authkey
  COMMAND change_authkey
  )

add_test(
  NAME encrypt_aes
  COMMAND encrypt_aes
  WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/examples"
)
set_tests_properties(encrypt_aes PROPERTIES SKIP_RETURN_CODE 64)

=== pkcs11/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()

set(
  SOURCE
  ../common/hash.c
  ../common/util.c
  ../common/parsing.c
  ../common/openssl-compat.c
  util_pkcs11.c
  yubihsm_pkcs11.c
  list.c
  debug_p11.c
  )

if(WIN32)
  set(SOURCE ${SOURCE} cmdline.c ../common/time_win.c ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
  include(${CMAKE_SOURCE_DIR}/cmake/getopt.cmake)
  find_getopt()
else(WIN32)
  include(gengetopt)
  add_gengetopt_files(cmdline "--conf-parser" "--no-handle-error" "--string-parser")
  set(SOURCE ${SOURCE} ${GGO_C})
endif(WIN32)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${LIBCRYPTO_INCLUDEDIR}
  )

# NOTE(adma): required by gengetopt
add_definitions(-DPACKAGE="yubihsm_pkcs11")
add_definitions(-DVERSION="${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}")
add_definitions(-DVERSION_MAJOR=${yubihsm_shell_VERSION_MAJOR})
add_definitions(-DVERSION_MINOR=${yubihsm_shell_VERSION_MINOR})
add_definitions(-DVERSION_PATCH=${yubihsm_shell_VERSION_PATCH})

list(APPEND LCOV_REMOVE_PATTERNS "'${PROJECT_SOURCE_DIR}/pkcs11/cmdline.c'")

if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
set_property(SOURCE ${GGO_C} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-unused-but-set-variable ")
endif()

add_library(yubihsm_pkcs11 SHARED ${SOURCE})
if (FUZZING AND ENABLE_STATIC)
    target_sources(yubihsm_pkcs11 PUBLIC ${PROJECT_SOURCE_DIR}/lib/fuzz/yubihsm_fuzz.cc)
    set_target_properties (yubihsm_pkcs11 PROPERTIES COMPILE_FLAGS "-DSTATIC ")
endif()
add_coverage (yubihsm_pkcs11)

# Remove "lib" form the built target
set_target_properties(yubihsm_pkcs11 PROPERTIES PREFIX "")

# Set install RPATH
set_target_properties(yubihsm_pkcs11 PROPERTIES INSTALL_RPATH "${YUBIHSM_INSTALL_LIB_DIR}")

if(NOT MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()
add_definitions(-DCRYPTOKI_EXPORTS)

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  # glibc provides the iconv functionality out of the box, this
  # will probably be required on other platforms besides macOS.
  set_target_properties(yubihsm_pkcs11 PROPERTIES LINK_FLAGS "-liconv")
endif()

target_link_libraries(
  yubihsm_pkcs11
  ${LIBCRYPTO_LDFLAGS}
  ${GETOPT_LIBS}
)

if(ENABLE_STATIC)
  target_link_libraries(yubihsm_pkcs11 yubihsm_static)
else()
  target_link_libraries(yubihsm_pkcs11 yubihsm)
endif()

if(WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc @ONLY)
endif(WIN32)

install(
  TARGETS yubihsm_pkcs11
  ARCHIVE DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}/pkcs11"
  LIBRARY DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}/pkcs11"
  RUNTIME DESTINATION "${YUBIHSM_INSTALL_BIN_DIR}/pkcs11")
install(FILES pkcs11.h DESTINATION "${YUBIHSM_INSTALL_INC_DIR}/pkcs11")
install(FILES pkcs11t.h DESTINATION "${YUBIHSM_INSTALL_INC_DIR}/pkcs11")
install(FILES pkcs11f.h DESTINATION "${YUBIHSM_INSTALL_INC_DIR}/pkcs11")
install(FILES pkcs11y.h DESTINATION "${YUBIHSM_INSTALL_INC_DIR}/pkcs11")

add_subdirectory (tests)

if (FUZZING)
    include_directories(
        ../lib/fuzz
    )
    add_executable(fuzz_get_attribute_value
        # harness sources
        fuzz/fuzz_get_attribute_value.cc
        ../lib/fuzz/yubihsm_fuzz.cc
        # pkcs11 sources
        ../common/hash.c
        ../common/util.c
        ../common/parsing.c
        ../common/openssl-compat.c
        util_pkcs11.c
        yubihsm_pkcs11.c
        list.c
        debug_p11.c
        # libyubihsm sources
        ../aes_cmac/aes.c
        ../aes_cmac/aes_cmac.c
        ../common/hash.c
        ../common/pkcs5.c
        ../common/rand.c
        ../common/ecdh.c
        ../common/openssl-compat.c
        ../lib/error.c
        ../lib/lib_util.c
        ../lib/yubihsm.c
        # cmdline sources
        ${GGO_C}
    )
    set_target_properties (fuzz_get_attribute_value PROPERTIES COMPILE_FLAGS "-DSTATIC -fsanitize=fuzzer")
    set_target_properties (fuzz_get_attribute_value PROPERTIES LINK_FLAGS "-fsanitize=fuzzer")
    target_link_libraries(fuzz_get_attribute_value ${LIBCRYPTO_LDFLAGS})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nested-anon-types")
endif (FUZZING)

=== src/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()

set (
  SOURCE
  commands.c
  main.c
  cmd_util.c
  ../common/util.c
  ../common/hash.c
  ../common/parsing.c
  ../common/openssl-compat.c
  )

if(WIN32)
  set(SOURCE ${SOURCE} cmdline.c)
  include(${CMAKE_SOURCE_DIR}/cmake/getopt.cmake)
  find_getopt()
else(WIN32)
  include(gengetopt)
  find_gengetopt ()
  add_gengetopt_files (cmdline "--conf-parser")
  set(SOURCE ${SOURCE} ${GGO_C})
endif(WIN32)

include_directories (
  ${LIBCRYPTO_INCLUDEDIR}
  ${LIBEDIT_INCLUDEDIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/../common
  )

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ykhsmauth)
set(YKHSMAUTH_LIB ykhsmauth)
set(YKHSMAUTH_LIB_STATIC ykhsmauth_static)

if(WIN32)
  list(APPEND SOURCE ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc @ONLY)
endif(WIN32)

# NOTE(adma): required by gengetopt
add_definitions (-DPACKAGE="yubihsm-shell")
add_definitions (-DVERSION="${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}")

list(APPEND LCOV_REMOVE_PATTERNS "'${PROJECT_SOURCE_DIR}/src/cmdline.c'")

add_executable (yubihsm-shell ${SOURCE})
if (ENABLE_STATIC AND NOT FUZZING)
  add_executable (yubihsm-shell_static ${SOURCE})
  set_target_properties (yubihsm-shell_static PROPERTIES COMPILE_FLAGS "-DSTATIC")
  target_link_libraries(yubihsm-shell_static
    ${LIBCRYPTO_LDFLAGS}
    ${LIBEDIT_LDFLAGS}
    ${GETOPT_LIBS}
    yubihsm_static
    ${YKHSMAUTH_LIB_STATIC})
  add_coverage (yubihsm-shell_static)
endif ()

target_link_libraries (
  yubihsm-shell
  ${LIBCRYPTO_LDFLAGS}
  ${LIBEDIT_LDFLAGS}
  ${GETOPT_LIBS}
  yubihsm
  ${YKHSMAUTH_LIB})

# Set install RPATH
set_target_properties(yubihsm-shell PROPERTIES INSTALL_RPATH "${YUBIHSM_INSTALL_LIB_DIR}")

add_coverage (yubihsm-shell)

install(
  TARGETS yubihsm-shell
  ARCHIVE DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}"
  LIBRARY DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}"
  RUNTIME DESTINATION "${YUBIHSM_INSTALL_BIN_DIR}")

if (NOT WITHOUT_MANPAGES)
  include (help2man)
  add_help2man_manpage (yubihsm-shell.1 yubihsm-shell)

  add_custom_target (yubihsm-shell-man ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/yubihsm-shell.1
    )

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/yubihsm-shell.1" DESTINATION "${YUBIHSM_INSTALL_MAN_DIR}/man1")
endif()

add_subdirectory (tests)

=== yhwrap/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()

set (
  SOURCE
  ../common/hash.c
  ../common/parsing.c
  ../common/pkcs5.c
  ../common/util.c
  ../common/openssl-compat.c
  main.c
  )

if(WIN32)
  set(SOURCE ${SOURCE} cmdline.c)
  include(${CMAKE_SOURCE_DIR}/cmake/getopt.cmake)
  find_getopt()
else(WIN32)
  include(gengetopt)
  add_gengetopt_files (cmdline)
  set(SOURCE ${SOURCE} ${GGO_C})
  message("${GGO_C}")
endif(WIN32)

include_directories (
  ${LIBCRYPTO_INCLUDEDIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/../lib
  ${CMAKE_CURRENT_SOURCE_DIR}/../common
)

if(${WIN32})
  list(APPEND SOURCE ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc @ONLY)
endif(${WIN32})

# NOTE(adma): required by gengetopt
add_definitions (-DPACKAGE="yubihsm-wrap")
add_definitions (-DVERSION="${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}")

list(APPEND LCOV_REMOVE_PATTERNS "'${PROJECT_SOURCE_DIR}/yhwrap/cmdline.c'")

if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
set_property(SOURCE ${GGO_C} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-unused-but-set-variable ")
endif()

add_executable (yubihsm-wrap ${SOURCE})

target_link_libraries (
  yubihsm-wrap
  ${LIBCRYPTO_LDFLAGS}
  ${GETOPT_LIBS}
  yubihsm
  )

set_target_properties(yubihsm-wrap PROPERTIES INSTALL_RPATH "${YUBIHSM_INSTALL_LIB_DIR}")

add_coverage(yubihsm-wrap)

install(
  TARGETS yubihsm-wrap
  ARCHIVE DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}"
  LIBRARY DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}"
  RUNTIME DESTINATION "${YUBIHSM_INSTALL_BIN_DIR}")

if (NOT WITHOUT_MANPAGES)
  include (help2man)
  add_help2man_manpage (yubihsm-wrap.1 yubihsm-wrap)

  add_custom_target (yubihsm-wrap-man ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/yubihsm-wrap.1
    )
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/yubihsm-wrap.1" DESTINATION "${YUBIHSM_INSTALL_MAN_DIR}/man1")
endif ()

=== ykhsmauth/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set (
  SOURCE
  error.c
  ykhsmauth.c
)

if(WIN32)
    set(SOURCE ${SOURCE} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
endif(WIN32)

include_directories (
  ${LIBPCSC_INCLUDEDIR}
)

# Uncomment this for Ubuntu 24.10 and higher and Fedora 41 and higher
#SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${LIBPCSC_CFLAGS}")

add_library (ykhsmauth SHARED ${SOURCE})

#add_definitions (-DVERSION="${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}")

target_link_libraries (ykhsmauth ${LIBPCSC_LDFLAGS})

set_target_properties (ykhsmauth PROPERTIES VERSION "${yubihsm_shell_VERSION_MAJOR}.${yubihsm_shell_VERSION_MINOR}.${yubihsm_shell_VERSION_PATCH}" SOVERSION ${yubihsm_shell_VERSION_MAJOR})

# Set install RPATH
set_target_properties(ykhsmauth PROPERTIES INSTALL_RPATH "${YUBIHSM_INSTALL_LIB_DIR}")

add_library (ykhsmauth_static STATIC ${SOURCE})
set_target_properties (ykhsmauth_static PROPERTIES POSITION_INDEPENDENT_CODE on OUTPUT_NAME ykhsmauth)
set_target_properties (ykhsmauth_static PROPERTIES COMPILE_FLAGS "-DSTATIC")
target_link_libraries (ykhsmauth_static ${LIBPCSC_LDFLAGS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykhsmauth.pc.in ${CMAKE_CURRENT_BINARY_DIR}/ykhsmauth.pc @ONLY)
if(WIN32)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/version.rc @ONLY)
endif(WIN32)

install(
  TARGETS ykhsmauth
  ARCHIVE DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}"
  LIBRARY DESTINATION "${YUBIHSM_INSTALL_LIB_DIR}"
  RUNTIME DESTINATION "${YUBIHSM_INSTALL_BIN_DIR}")
install(FILES ykhsmauth.h DESTINATION ${YUBIHSM_INSTALL_INC_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ykhsmauth.pc DESTINATION ${YUBIHSM_INSTALL_PKGCONFIG_DIR})

=== src/tests/CMakeLists.txt ===
#
# Copyright 2015-2018 Yubico AB
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

find_program (BASH_PROGRAM bash)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/data.txt
  ${CMAKE_CURRENT_BINARY_DIR}/data.txt
  COPYONLY)

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/sig.out
  ${CMAKE_CURRENT_BINARY_DIR}/sig.out
  COPYONLY)

add_test(
  NAME bash_tests
  COMMAND ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tests.sh
  )

add_test(
  NAME wrapped_tests
  COMMAND ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/wrapped_tests.sh
  )

=== debian/changelog ===
yubihsm-shell (2.7.0-3) unstable; urgency=medium

  * Don't build shared libraries with -pie (closes: #1113655).

 -- Colin Watson <cjwatson@debian.org>  Fri, 26 Sep 2025 13:58:24 +0100

yubihsm-shell (2.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Sun, 10 Aug 2025 10:38:27 +0100

yubihsm-shell (2.7.0-1) experimental; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Mon, 16 Jun 2025 11:39:07 +0100

=== debian/control ===
Source: yubihsm-shell
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Freexian Packaging Team <team+freexian@tracker.debian.org>,
 Colin Watson <cjwatson@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.29),
 gengetopt,
 help2man,
 libcurl4-openssl-dev,
 libedit-dev,
 libpcsclite-dev,
 libssl-dev,
 libusb-1.0-0-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://developers.yubico.com/yubihsm-shell/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/yubihsm-shell
Vcs-Git: https://salsa.debian.org/pkg-security-team/yubihsm-shell.git
X-Style: black

Package: libyubihsm2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libyubihsm-http2 (= ${binary:Version}) | libyubihsm-usb2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
# Upstream's library package names don't match the SONAME.
Breaks:
 libyubihsm1,
Replaces:
 libyubihsm1,
Description: YubiHSM 2 communication library
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the main run-time shared library.

Package: libyubihsm-usb2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libyubihsm2,
# Upstream's library package names don't match the SONAME.
Breaks:
 libyubihsm-usb1,
Replaces:
 libyubihsm-usb1,
Description: YubiHSM 2 communication library (direct USB access)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains backend functions used by libyubihsm2 to access the
 device directly over USB.

Package: libyubihsm-http2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libyubihsm2,
Suggests:
 yubihsm-connector,
# Upstream's library package names don't match the SONAME.
Breaks:
 libyubihsm-http1,
Replaces:
 libyubihsm-http1,
Description: YubiHSM 2 communication library (HTTP access)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains backend functions used by libyubihsm2 to access the
 device over HTTP via yubihsm-connector.

Package: libyubihsm-dev
Section: libdevel
Architecture: any
Depends:
 libyubihsm2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: YubiHSM 2 communication library (development files)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the development files for the library.

Package: libykhsmauth2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
# Upstream's library package names don't match the SONAME.
Breaks:
 libykhsmauth1,
Replaces:
 libykhsmauth1,
Description: YubiKey HSM authentication library
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains a run-time shared library for interacting with the
 HSM authentication application on a YubiKey, which can be used to access
 the YubiHSM 2.

Package: libykhsmauth-dev
Section: libdevel
Architecture: any
Depends:
 libykhsmauth2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: YubiKey HSM authentication library (development files)
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains development files for the library to interact with
 the HSM authentication application on a YubiKey, which can be used to
 access the YubiHSM 2.

Package: yubihsm-pkcs11
Section: libs
Architecture: any
Depends:
 libyubihsm2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: PKCS#11 module for communication with the YubiHSM 2
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains a PKCS#11 module, allowing software that supports
 that interface standard to use a YubiHSM 2 device.

Package: yubihsm-shell
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: command-line and interactive tool for the YubiHSM 2
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the yubihsm-shell command-line tool for interacting
 with the YubiHSM 2.

Package: yubihsm-wrap
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: produce offline wrapped objects for the YubiHSM 2
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 YubiHSM 2 devices support exporting and importing objects under a Wrap Key,
 allowing them to be transferred between devices while preserving
 confidentiality.  This package contains the yubihsm-wrap command-line tool
 to allow creating wrapped objects from a computer.

Package: yubihsm-auth
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: store YubiHSM 2 authentication keys on a YubiKey
 The YubiHSM 2 is a USB-attached device for managing cryptographic keys.
 .
 This package contains the yubihsm-auth command-line tool to store
 authentication keys for a YubiHSM 2 on a YubiKey.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_CPPFLAGS_MAINT_APPEND := -I/usr/include/PCSC

# We build without RPATH, so we need to set LD_LIBRARY_PATH in order that
# built programs can be run from the build tree.
builddir := $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)
LD_LIBRARY_PATH := $(builddir)/lib:$(builddir)/ykhsmauth

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DRELEASE_BUILD=1 \
		-DYUBIHSM_INSTALL_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

override_dh_auto_build:
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) dh_auto_build

override_dh_auto_test:
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) dh_auto_test -- \
		ARGS+=--exclude-from-file ARGS+=$(CURDIR)/debian/ctest-exclude

=== debian/watch ===
version=4
https://developers.yubico.com/yubihsm-shell/Releases/ \
    @PACKAGE@-(\d[\d.]*)@ARCHIVE_EXT@
